﻿Imports System.Windows.Forms
Imports Nios4

Public Class CReportNios4

    Implements Nios4.IReportE

    Dim _Displayable As Double = 1
    Dim _GGUID As String = "AAAAAAAAAA"
    Dim _ReportGroup As String = "Test Report"
    Dim _ReportName As String = "Template Report"
    Dim _Seed As String = "*"

    Public Property Displayable As Double Implements IReportE.Displayable
        Get
            Return _Displayable
        End Get
        Set(value As Double)
            _Displayable = value
        End Set
    End Property

    Public Property GGUID As String Implements IReportE.GGUID
        Get
            Return _GGUID
        End Get
        Set(value As String)
            _GGUID = value
        End Set
    End Property

    Public Property N4 As CNios4 Implements IReportE.N4
        Get
            Return NI4
        End Get
        Set(value As CNios4)
            NI4 = value
        End Set
    End Property

    Public Property PanelReport As Control Implements IReportE.PanelReport
        Get
            Return COPanelReport
        End Get
        Set(value As Control)
            COPanelReport = value
        End Set
    End Property


    Public Property ReportGroup As String Implements IReportE.ReportGroup
        Get
            Return _ReportGroup
        End Get
        Set(value As String)
            _ReportGroup = value
        End Set
    End Property

    Public Property ReportName As String Implements IReportE.ReportName
        Get
            Return _ReportName
        End Get
        Set(value As String)
            _ReportName = value
        End Set
    End Property

    Public Property Seed As String Implements IReportE.Seed
        Get
            Return _Seed
        End Get
        Set(value As String)
            _Seed = value
        End Set
    End Property

    Public Sub Update() Implements IReportE.Update
        'update report
        COPanelReport.Label1.Text = "PANEL UPDATE!" & vbCrLf & Now.ToString
    End Sub

    Public Sub Execute() Implements IReportE.PushExecute

        Dim ta As DataTable = NI4.Database.getsql("SELECT * FROM tablename")
        If IsNothing(ta) = True Then
            MsgBox(NI4.Database.ErrorN4.Message)
        End If

    End Sub

    Public Sub Actions(Position As System.Drawing.Point) Implements IReportE.PushActions

        NI4.Utility.Popup_reset()

        Dim p1 As New Nios4.CNios4.PopupEvent
        p1.PayLoad.Add("Test", "Test1")
        AddHandler p1.Execute, AddressOf ExecutePopUp
        NI4.Utility.Popup_additem("Test1", Nothing, Me, p1)

        Dim p2 As New Nios4.CNios4.PopupEvent
        p2.PayLoad.Add("Test", "Test2")
        AddHandler p2.Execute, AddressOf ExecutePopUp
        NI4.Utility.Popup_additem("Test2", Nothing, Me, p2)


        NI4.Utility.Popup_show(Position)

    End Sub

    Public Sub ExecutePopUp(Sender As Nios4.CNios4.PopupEvent)

        MsgBox("Press " & Sender.PayLoad("Test"))

    End Sub

End Class
